package jp.gr.java_conf.abagames.river;

import jp.gr.java_conf.abagames.util.j3d.*;
import javax.media.j3d.*;

/**
  ڍ锠
  */
public class Box {

  private Shape3D getShape3D() {
    float[] cordinates = {
     -9,-17,-21, -9,-17,21, 9,-17,21, 9,-17,-21,
     -9,17,-21, -9,17,21, 9,17,21, 9,17,-21,
     -9,17,15, 9,17,15};
    int[] cordinateIndices = {
     1,2,6,5, 8,5,6,9, 4,0,3,7, 0,4,5,1, 2,6,7,3};
    float[] colors = {1,0.9f,0.9f};
    int[] colorIndices = {
     0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0};
    float[] normals = {
     0,1,0, 0,0,1, 0,1,0, 0,0,1, 1,0,0, -1,0,0};
    int[] normalIndices = {
     1,1,1,1, 2,2,2,2, 3,3,3,3, 4,4,4,4, 5,5,5,5};

    IndexedQuadArray gmt = new IndexedQuadArray(
     10,
     IndexedQuadArray.COORDINATES
      | IndexedQuadArray.COLOR_3
      | IndexedQuadArray.NORMALS,
     24);
    gmt.setCoordinates(0, cordinates);
    gmt.setCoordinateIndices(0, cordinateIndices);
    gmt.setColors(0, colors);
    gmt.setColorIndices(0, colorIndices);
    gmt.setNormals(0, normals);
    gmt.setNormalIndices(0, normalIndices);

    Material mtr = new Material();
    mtr.setLightingEnable(true);
    Appearance app = new Appearance();
    app.setMaterial(mtr);

    return new Shape3D(gmt, app);
  }

  public TrnsObj to;

  public Box() {
    to = new TrnsObj(getShape3D());
  }
}

