package jp.gr.java_conf.abagames.util.j3d;

import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.universe.*;

/**
  V[OtǗpNX
  */
public class Scene {
  /**
    obNOEh̃NbsO͈
    */
  final public double BACKGROUND_DISTANCE = 100.0;
  /**
    ̉e͈
    */
  final public double LIGHT_SPHERE_DISTANCE = 100.0;
  /**
    V[Ot̃[g
    */
  public BranchGroup root;

  private BoundingSphere lightBounds;
  private TransformGroup viewpoint;
  private SimpleUniverse u;

  /**
    @param canvas3D ̃V[\Canvas3D
    */
  public Scene(Canvas3D canvas3D) {
    u = new SimpleUniverse(canvas3D);
    ViewingPlatform vplt = u.getViewingPlatform();
    viewpoint = vplt.getViewPlatformTransform();
    View view = canvas3D.getView();
    view.setBackClipDistance(BACKGROUND_DISTANCE);
    lightBounds = new BoundingSphere(new Point3d(0, 0, 0), LIGHT_SPHERE_DISTANCE);
    root = new BranchGroup();
  }

  /**
    _̐ݒ
    */
  public void setViewpoint(Transform3D trns) {
    viewpoint.setTransform(trns);
  }

  /**
    ̐ݒ
    */
  public void addLight(Light light) {
    light.setInfluencingBounds(lightBounds);
    root.addChild(light);
  }

  /**
    V[̃_OJn
    */
  public void validate() {
    u.addBranchGraph(root);
  }
}

