package jp.gr.java_conf.abagames.river;

import jp.gr.java_conf.abagames.util.j3d.*;
import javax.media.j3d.*;
import javax.vecmath.*;

/**
  {[iXLN^
  */
public class Bonus {

  private Shape3D getShape3D() {
    float[] cordinates = {
     0,0,-1, -0.86f,0,0.5f, 0.86f,0,0.5f, 0,1,0, 0,-1,0};
    int[] cordinateIndices = {
     0,1,3, 1,2,3, 2,0,3, 1,0,4, 2,1,4, 0,2,4};
    float[] colors = {1,1,0.3f};
    int[] colorIndices = {
     0,0,0, 0,0,0, 0,0,0, 0,0,0, 0,0,0, 0,0,0};

    IndexedTriangleArray gmt = new IndexedTriangleArray(
     5,
     IndexedTriangleArray.COORDINATES
      | IndexedTriangleArray.COLOR_3
      | IndexedTriangleArray.NORMALS,
     18);
    gmt.setCoordinates(0, cordinates);
    gmt.setCoordinateIndices(0, cordinateIndices);
    gmt.setColors(0, colors);
    gmt.setColorIndices(0, colorIndices);
    gmt.setNormals(0, cordinates);
    gmt.setNormalIndices(0, cordinateIndices);

    Material mtr = new Material();
    mtr.setLightingEnable(true);
    mtr.setEmissiveColor(new Color3f(0.5f, 0.5f, 0));
    Appearance app = new Appearance();
    app.setMaterial(mtr);

    return new Shape3D(gmt, app);
  }

  public TrnsObj to;

  public Bonus() {
    to = new TrnsObj(getShape3D());
  }
}

