package jp.gr.java_conf.abagames.river;

import jp.gr.java_conf.abagames.util.j3d.*;
import javax.media.j3d.*;

/**
  ̐
  */
public class Cube {

  private Shape3D getShape3D() {
    float[] cordinates = {
     -1,-1,-1, -1,-1,1, 1,-1,1, 1,-1,-1,
     -1,1,-1, -1,1,1, 1,1,1, 1,1,-1};
    int[] cordinateIndices = {
     0,3,2,1, 1,2,6,5, 4,5,6,7, 4,7,3,0, 0,1,5,4, 2,3,7,6};
    float[] colors = {
     1,0.6f,0.4f};
    int[] colorIndices = {
     0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0};

    IndexedQuadArray gmt = new IndexedQuadArray(
     8,
     IndexedQuadArray.COORDINATES
      | IndexedQuadArray.COLOR_3
      | IndexedQuadArray.NORMALS,
     24);
    gmt.setCoordinates(0, cordinates);
    gmt.setCoordinateIndices(0, cordinateIndices);
    gmt.setColors(0, colors);
    gmt.setColorIndices(0, colorIndices);
    gmt.setNormals(0, cordinates);
    gmt.setNormalIndices(0, cordinateIndices);

    Material mtr = new Material();
    mtr.setLightingEnable(true);
    Appearance app = new Appearance();
    app.setMaterial(mtr);

    return new Shape3D(gmt, app);
  }

  public TrnsObj to;

  public Cube() {
    to = new TrnsObj(getShape3D());
  }
}
