package jp.gr.java_conf.abagames.river;

import javax.media.j3d.*;
import com.sun.j3d.utils.universe.SimpleUniverse;
import java.awt.*;
import java.awt.event.*;

/**
  ڍ tH[
  */
public class RiverUI extends Frame {
  Canvas3D canvas3D = new Canvas3D(SimpleUniverse.getPreferredConfiguration());

  public RiverUI() {
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public Canvas3D getCanvas3D() {
    return canvas3D;
  }

  private void jbInit() throws Exception {
    setSize(240, 320);
    this.addWindowListener(new java.awt.event.WindowAdapter() {

      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }
    });
    this.setTitle("The River Meguro");
    canvas3D.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        canvas3D_keyPressed(e);
      }

      public void keyReleased(KeyEvent e) {
        canvas3D_keyReleased(e);
      }
    });
    add(canvas3D, BorderLayout.CENTER);
  }

  void this_windowClosing(WindowEvent e) {
    System.exit(0);
    //dispose();
  }

  public boolean leftPressed = false, rightPressed = false;

  void canvas3D_keyPressed(KeyEvent e) {
    switch ( e.getKeyCode() ) {
      case KeyEvent.VK_LEFT:
        leftPressed = true;
        break;
      case KeyEvent.VK_RIGHT:
        rightPressed = true;
        break;
    }
  }

  void canvas3D_keyReleased(KeyEvent e) {
    switch ( e.getKeyCode() ) {
      case KeyEvent.VK_LEFT:
        leftPressed = false;
        break;
      case KeyEvent.VK_RIGHT:
        rightPressed = false;
        break;
    }
  }
}

